def pyqt5() -> None:
    print("Running on PyQt5")

    from PyQt5.QtDBus import QDBusArgument, QDBusConnection, QDBusMessage, QDBusVariant

    arg = QDBusArgument()
    arg.beginStructure()
    arg.add("Test")
    arg.endStructure()

    conn = QDBusConnection.sessionBus()
    msg = QDBusMessage.createMethodCall("com.example.App", "/com/example/App", "com.example.App", "Example")
    msg.setArguments([QDBusVariant(arg)])
    conn.call(msg)

    print("You should see no error")


def pyqt6() -> None:
    print("Running on PyQt6")

    from PyQt6.QtDBus import QDBusArgument, QDBusConnection, QDBusMessage, QDBusVariant

    arg = QDBusArgument()
    arg.beginStructure()
    arg.add("Test")
    arg.endStructure()

    conn = QDBusConnection.sessionBus()
    msg = QDBusMessage.createMethodCall("com.example.App", "/com/example/App", "com.example.App", "Example")
    msg.setArguments([QDBusVariant(arg)])
    conn.call(msg)

    print("You should see a marshalling error")


def main() -> None:
    pyqt5()
    pyqt6()


if __name__ == "__main__":
    main()
